namespace Turbo.Plugins.LightningMod
{
    public class WizardArchonPlugin : AbstractSkillHandler, ISkillHandler
    {
        public int buffStack { get; set; }
        public WizardArchonPlugin()
            : base(CastType.BuffSkill, CastPhase.AutoCast, CastPhase.UseWpStart, CastPhase.Move, CastPhase.Attack, CastPhase.AttackIdle)
        {
            Enabled = false;
            buffStack = 20;
        }
        public override void Load(IController hud)
        {
            base.Load(hud);
            AssignedSnoPower = Hud.Sno.SnoPowers.Wizard_Archon;
            CreateCastRule()
                .IfInTown().ThenNoCastElseContinue()
                .IfCastingIdentify().ThenNoCastElseContinue()
                .IfCastingPortal().ThenNoCastElseContinue()
                .IfCanCastBuff().ThenContinueElseNoCast()
                .IfCanCastSimple().ThenContinueElseNoCast()
                .IfOnCooldown().ThenNoCastElseContinue()
                .IfEnoughMonstersNearby(ctx => 100, ctx => 1).ThenContinueElseNoCast()
                .IfTrue(ctx =>
                {
                    bool active = false;
                    var buff = Hud.Game.Me.Powers.GetBuff(440235);
                    if ((buff != null && buff.IconCounts[0] >= buffStack) || Hud.Game.Me.Defense.HealthPct < 99)
                    {
                        active = true;
                    }
                    return active;
                }).ThenCastElseContinue()
				.IfSpecificBuffIsActive(Hud.Sno.SnoPowers.Wizard_StormArmor, 4).ThenContinueElseNoCast()
				.IfSpecificBuffIsAboutToExpire(hud.Sno.SnoPowers.Wizard_Archon, 5, 100, 200).ThenCastElseContinue();
        }
    }
}